---
title: Cross-Origin-Opener-Policy
slug: Web/HTTP/Headers/Cross-Origin-Opener-Policy
tags:
  - HTTP
  - HTTP Header
  - Reference
  - Response Header
  - header
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP <strong><code>Cross-Origin-Opener-Policy</code></strong> (COOP) response header allows you to ensure a top-level document does not share a browsing context group with cross-origin documents.</p>

<p>COOP will process-isolate your document and potential attackers can't access to your global object if they were opening it in a popup, preventing a set of cross-origin attacks dubbed <a href="https://github.com/xsleaks/xsleaks">XS-Leaks</a>.</p>

<p>If a cross-origin document with COOP is opened in a new window, the opening document will not have a reference to it, and the <code><a href="/en-US/docs/Web/API/Window/opener">window.opener</a></code> property of the new window will be <code>null</code>. This allows you to have more control over references to a window than <code><a href="/en-US/docs/Web/HTML/Link_types/noopener">rel=noopener</a></code>, which only affects outgoing navigations.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Cross-Origin-Opener-Policy: unsafe-none | same-origin-allow-popups | same-origin
</pre>

<h3 id="Directives">Directives</h3>

<dl>
 <dt><code>unsafe-none</code></dt>
 <dd>This is the default value. Allows the document to be added to its opener's browsing context group unless the opener itself has a COOP of <code>same-origin</code> or <code>same-origin-allow-popups</code>.</dd>
 <dt><code>same-origin-allow-popups</code></dt>
 <dd>Retains references to newly opened windows or tabs which either don't set COOP or which opt out of isolation by setting a COOP of <code>unsafe-none</code>.</dd>
 <dt><code>same-origin</code></dt>
 <dd>Isolates the browsing context exclusively to same-origin documents. Cross-origin documents are not loaded in the same browsing context.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Certain_features_depend_on_cross-origin_isolation">Certain features depend on cross-origin isolation</h3>

<p>Certain features like {{jsxref("SharedArrayBuffer")}} objects or {{domxref("Performance.now()")}} with unthrottled timers are only available if your document has a COOP header with the value <code>same-origin</code> value set.</p>

<pre class="notranslate">Cross-Origin-Opener-Policy: same-origin
Cross-Origin-Embedder-Policy: require-corp
</pre>

<p>See also the {{HTTPHeader("Cross-Origin-Embedder-Policy")}} header which you'll need to set as well.</p>

<p>To check if cross-origin isolation has been successful, you can test against the <code><a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/crossOriginIsolated">crossOriginIsolated</a></code> property available to window and worker contexts:</p>

<pre class="brush: js notranslate">if (crossOriginIsolated) {
  // Post SharedArrayBuffer
} else {
  // Do something else
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#the-cross-origin-opener-policy-header', 'Cross-Origin-Opener-Policy header')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Cross-Origin-Opener-Policy")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{httpheader("Cross-Origin-Embedder-Policy")}}</li>
</ul>
